//------------------------------------------------------------------------------
// ȭϸ : serial.c
//    : ezBoot ø  ƾ̴. 
// 
// ۼ : â ()̴Ƽ frog@falinux.com
// ۼ : 2003 05 20
//    : 2003-06-07	 ()̴Ƽ freefrug@falinux.com  -- Ǫ
//          
// ۱ : ()̴Ƽ 
//    :  ƾ κ blob Դ. 
//------------------------------------------------------------------------------

//******************************************************************************
//
//  
//
//******************************************************************************
#include <pxa255.h>
//#include <config.h>
#include <serial.h>
#include <time.h>
#include <stdio.h>
#include <gpio.h>

//  ȭ pxa255.h  ִ __REG ũθ Ϲ   Ų. 
#define __REG(x)	              (x) 

//******************************************************************************
//
//   
//
//******************************************************************************
// config.c  
static int SerialErrorFlag = 0;

static volatile Word *UART = (volatile Word *) STUART; // UART ̽ 巹 

#define UART_DATA          	((volatile Word) UART[0] )  // Ÿ  
#define UART_IER		((volatile Word) UART[1] )  // ͷƮ 㰡 
#define UART_FCR		((volatile Word) UART[2] )  // ͷƮ  
#define UART_LCR		((volatile Word) UART[3] )  //  Ʈ 
#define UART_MCR		((volatile Word) UART[4] )  //  Ʈ 
#define UART_LSR		((volatile Word) UART[5] )  //   
#define UART_MSR		((volatile Word) UART[6] )  //   
#define UART_SPR		((volatile Word) UART[7] )  // 
#define UART_ISR		((volatile Word) UART[8] )  // ܼ Ʈ  
                                                
#define UART_DLL		((volatile Word) UART[0] )  // UART   
#define UART_DLH           	((volatile Word) UART[1] )  // UART   

//******************************************************************************
//
// Լ 
//
//******************************************************************************
//------------------------------------------------------------------------------
//  : ø ̽  ڸ . 
// Ű :  
// ȯ :  
//  :  
//------------------------------------------------------------------------------
void SerialOutChar( const char c  )
{
	//  Ҷ ٸ. 
	while(( UART_LSR & LSR_TDRQ ) == 0 ); 

	// ø Ÿ Ѵ. 
	UART_DATA = c;
}

//------------------------------------------------------------------------------
//  : ø ̽  ڸ . 
// Ű :  
// ȯ :  
//  : CR  LR CR  Ͽ Ѵ. 
//------------------------------------------------------------------------------
void SerialOutChar_CheckCR( const char c  )
{
	SerialOutChar( c );
	if(c == '\n') SerialOutChar('\r');
}
//------------------------------------------------------------------------------
//  : ø ̽ ڿ . 
// Ű :  
// ȯ :  
//  :  
//------------------------------------------------------------------------------
int SerialOutStr( char *str, int size )
{
	int	lp ;

	for (lp=0;lp<size;lp++) SerialOutChar(str[lp]) ;

	return lp;
}
//------------------------------------------------------------------------------
//  : ø ̽ ڿ . 
// Ű :  
// ȯ :  
//  :  
//------------------------------------------------------------------------------
int SerialOutStr_CheckCR( char *str, int size )
{
	int	lp ;

	for (lp=0;lp<size;lp++) SerialOutChar_CheckCR(str[lp]) ;

	return lp;
}
//------------------------------------------------------------------------------
//  : ø ̽ ŵ Ÿ ִ ȮѴ. 
// Ű :  
// ȯ : ŵ Ÿ  1 /  0
//  :  
//------------------------------------------------------------------------------
int SerialIsReadyChar( void )
{
	// ŵ Ÿ ִ° ȮѴ. 
	if( UART_LSR & LSR_DR ) return 1;
	return 0;
}

//------------------------------------------------------------------------------
//  : ø ¸  ش. 
// Ű :  
// ȯ : ŵ Ÿ  1 /  0
//  :  
//------------------------------------------------------------------------------
int SeriallGet_LSR( void )
{
	return UART_LSR;
}
//------------------------------------------------------------------------------
//  : ø ̽  ¸ о ´. 
// Ű :  
// ȯ : ŵ  
//  :  
//------------------------------------------------------------------------------
char SerialIsGetChar( void )
{
	//   ´. 
    	SerialErrorFlag = UART_LSR & (LSR_PE | LSR_FE | LSR_OE);
    
	// ŵ Ÿ  ´. 
	return (char) UART_DATA;
}
//------------------------------------------------------------------------------
//  : ø ̽   ö׸ Ŭ Ѵ. 
// Ű :  
// ȯ : ŵ  
//  :  
//------------------------------------------------------------------------------
char SerialIsClearError( void )
{
	SerialErrorFlag = 0;
	return (char)SerialErrorFlag;
}
//------------------------------------------------------------------------------
//  : ø ̽   ö  ´. 
// Ű :  
// ȯ : ŵ  
//  :  
//------------------------------------------------------------------------------
int SerialIsGetError( void )
{
	return SerialErrorFlag;
}


